/**
 * JORM: an implementation of a generic mapping system for persistent Java
 *       objects. Two mappings are supported: to RDBMS and to binary files.
 * Copyright (C) 2001-2004 France Telecom R&D - INRIA
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Contact: jorm-team@objectweb.org
 *
 */

package jorm;

import org.objectweb.jorm.naming.api.PBinder;
import org.objectweb.jorm.naming.api.PExceptionNaming;
import org.objectweb.jorm.api.PExceptionProtocol;
import org.objectweb.jorm.api.PException;
import org.objectweb.jorm.naming.api.PName;
import org.objectweb.jorm.naming.api.PNameCoder;
import org.objectweb.jorm.api.PSerializable;
import org.objectweb.jorm.api.PAccessor;
import org.objectweb.jorm.api.PAccessorGen;
import org.objectweb.jorm.api.PClassMapping;

public class Olstore_pictureSerializable implements PSerializable, Olstore_pictureAccessor {

	//the pname of the object
	protected String pName;
	
		protected java.lang.Integer JONASAUTOPKFIELD;
			protected  String jonasCMRItem_Picture;
			protected java.lang.String location;
			protected int priority;
			protected java.lang.String text;
	
	public String setPName(PName pName){
		if(pName.codingSupported((short) PNameCoder.CTSTRING)){
			try{
				this.pName  = pName.encodeString();
			}
			catch(Exception e){
			}
		}
		else{
			this.pName = "null";
		}
		return this.pName;
	}
	
	public PName getPName(PBinder pnc) throws PExceptionNaming{
		try{
			return pnc.decodeString(pName);
		}catch (Exception e) {
              throw new PExceptionNaming("Cannot decode to a PName: " + e.getMessage());
        }
	}
	
	public String getClassName(){
		return "jorm.Olstore_picture";
	}
	

	public void paSetJONASAUTOPKFIELD(java.lang.Integer val){
		JONASAUTOPKFIELD = val;
	}
	public java.lang.Integer paGetJONASAUTOPKFIELD() {
		return JONASAUTOPKFIELD;
	}

	public void paSetJonasCMRItem_Picture(PName val, Object connection){
		if(val.codingSupported((short) PNameCoder.CTSTRING)){
			try{
				jonasCMRItem_Picture = val.encodeString();
			}
			catch(Exception e){
			}
		}
		else{
			jonasCMRItem_Picture = "null";
		}
	}
	
	public PName paGetJonasCMRItem_Picture(Object hints){
		PNameCoder pnc;
		if(hints instanceof PClassMapping){
			PClassMapping pcm = (PClassMapping) hints;
			pnc = pcm.getPNameCoder("jonasCMRItem_Picture");
		}
		else{
			if(hints instanceof PNameCoder){
				pnc = (PNameCoder) hints;
			}
			else
				return null;
		}
		try{
			return pnc.decodeString(jonasCMRItem_Picture);
		}
		catch(PException e){
			return null;
		}
	}

	public void paSetLocation(java.lang.String val){
		location = val;
	}
	public java.lang.String paGetLocation() {
		return location;
	}

	public void paSetPriority(int val){
		priority = val;
	}
	public int paGetPriority() {
		return priority;
	}

	public void paSetText(java.lang.String val){
		text = val;
	}
	public java.lang.String paGetText() {
		return text;
	}

	public Object getMemoryInstance(){
		return this;
	}
	
	
	public String toString(){
		StringBuffer s = new StringBuffer();
		s.append("data(");
					s.append(JONASAUTOPKFIELD + ",  ");
					s.append(jonasCMRItem_Picture + ",  ");
					s.append(location + ",  ");
					s.append(priority + ",  ");
					s.append(text + ",  ");
				s.append(pName + ")");
		return s.toString();
	}
	
	
	public void read(PClassMapping pcm, PAccessor pa) throws PException{
		Olstore_pictureAccessor paccessor = null;
		PAccessorGen paccessorGen = null;
		if (pa == null)
			throw new PException("Accessor must not be null");
		else if (pa instanceof Olstore_pictureAccessor)
			paccessor = (Olstore_pictureAccessor) pa;
		else if (pa instanceof PAccessorGen)
			paccessorGen = (PAccessorGen) pa;
		else
			throw new PException("Wrong type of accessor: " + pa);
	 	try {	
			if(paccessor != null){
											paccessor.paSetJONASAUTOPKFIELD(paGetJONASAUTOPKFIELD());
															paccessor.paSetJonasCMRItem_Picture(paGetJonasCMRItem_Picture(pcm), null);
															paccessor.paSetLocation(paGetLocation());
															paccessor.paSetPriority(paGetPriority());
															paccessor.paSetText(paGetText());
							 			}
 			else{
	  		 			        		//paccessorGen.paSetOintField("JONASAUTOPKFIELD", paGetJONASAUTOPKFIELD(pcm), null);
	        			 						 			        		//paccessorGen.paSetStringField("location", paGetLocation(pcm), null);
	        			 			        		//paccessorGen.paSetIntField("priority", paGetPriority(pcm), null);
	        			 			        		//paccessorGen.paSetStringField("text", paGetText(pcm), null);
	        			        	 }  
		}
 		catch (PException pe) {
			throw pe;
		} catch (Exception e) {
			throw new PException(e.toString());
		} 
	}
	
	public void write(PClassMapping pcm, PAccessor pa) throws PException{
		Olstore_pictureAccessor paccessor = null;
		PAccessorGen paccessorGen = null;
		if (pa == null)
			throw new PExceptionProtocol("Accessor must not be null");
		else if (pa instanceof Olstore_pictureAccessor)
			paccessor = (Olstore_pictureAccessor) pa;
		else if (pa instanceof PAccessorGen)
			paccessorGen = (PAccessorGen) pa;
		else
			throw new PExceptionProtocol("Wrong type of accessor: " + pa);
		try {	
			if(paccessor != null){
											paSetJONASAUTOPKFIELD(paccessor.paGetJONASAUTOPKFIELD());
															paSetJonasCMRItem_Picture(paccessor.paGetJonasCMRItem_Picture(pcm), null);
															paSetLocation(paccessor.paGetLocation());
															paSetPriority(paccessor.paGetPriority());
															paSetText(paccessor.paGetText());
							 			}
 			else{
	  		 				        	//	paSetOintField(JONASAUTOPKFIELD, paccessorGen.paGetJONASAUTOPKFIELD());
        		//paSetOintField("JONASAUTOPKFIELD", paccessorGen.paGetOintField("JONASAUTOPKFIELD"));
        		//paSetJONASAUTOPKFIELD(paccessorGen.paGetOintField("JONASAUTOPKFIELD"), null);
	        			 						 				        	//	paSetStringField(location, paccessorGen.paGetLocation());
        		//paSetStringField("location", paccessorGen.paGetStringField("location"));
        		//paSetLocation(paccessorGen.paGetStringField("location"), null);
	        			 				        	//	paSetIntField(priority, paccessorGen.paGetPriority());
        		//paSetIntField("priority", paccessorGen.paGetIntField("priority"));
        		//paSetPriority(paccessorGen.paGetIntField("priority"), null);
	        			 				        	//	paSetStringField(text, paccessorGen.paGetText());
        		//paSetStringField("text", paccessorGen.paGetStringField("text"));
        		//paSetText(paccessorGen.paGetStringField("text"), null);
	        			        	 }  
		}
 		catch (PException pe) {
			throw pe;
		} catch (Exception e) {
			throw new PException(e.toString());
		} 
	}
}