/**
 * JORM: an implementation of a generic mapping system for persistent Java
 *       objects. Two mappings are supported: to RDBMS and to binary files.
 * Copyright (C) 2001-2004 France Telecom R&D - INRIA
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Contact: jorm-team@objectweb.org
 *
 */

package jorm;

import org.objectweb.jorm.naming.api.PBinder;
import org.objectweb.jorm.naming.api.PExceptionNaming;
import org.objectweb.jorm.api.PExceptionProtocol;
import org.objectweb.jorm.api.PException;
import org.objectweb.jorm.naming.api.PName;
import org.objectweb.jorm.naming.api.PNameCoder;
import org.objectweb.jorm.api.PSerializable;
import org.objectweb.jorm.api.PAccessor;
import org.objectweb.jorm.api.PAccessorGen;
import org.objectweb.jorm.api.PClassMapping;

public class Olstore_propertySerializable implements PSerializable, Olstore_propertyAccessor {

	//the pname of the object
	protected String pName;
	
		protected java.lang.Integer JONASAUTOPKFIELD;
			protected  String jonasCMRItem_Property;
			protected  String jonasCMRType_Property;
			protected java.lang.String name;
			protected java.lang.String value;
	
	public String setPName(PName pName){
		if(pName.codingSupported((short) PNameCoder.CTSTRING)){
			try{
				this.pName  = pName.encodeString();
			}
			catch(Exception e){
			}
		}
		else{
			this.pName = "null";
		}
		return this.pName;
	}
	
	public PName getPName(PBinder pnc) throws PExceptionNaming{
		try{
			return pnc.decodeString(pName);
		}catch (Exception e) {
              throw new PExceptionNaming("Cannot decode to a PName: " + e.getMessage());
        }
	}
	
	public String getClassName(){
		return "jorm.Olstore_property";
	}
	

	public void paSetJONASAUTOPKFIELD(java.lang.Integer val){
		JONASAUTOPKFIELD = val;
	}
	public java.lang.Integer paGetJONASAUTOPKFIELD() {
		return JONASAUTOPKFIELD;
	}

	public void paSetJonasCMRItem_Property(PName val, Object connection){
		if(val.codingSupported((short) PNameCoder.CTSTRING)){
			try{
				jonasCMRItem_Property = val.encodeString();
			}
			catch(Exception e){
			}
		}
		else{
			jonasCMRItem_Property = "null";
		}
	}
	
	public PName paGetJonasCMRItem_Property(Object hints){
		PNameCoder pnc;
		if(hints instanceof PClassMapping){
			PClassMapping pcm = (PClassMapping) hints;
			pnc = pcm.getPNameCoder("jonasCMRItem_Property");
		}
		else{
			if(hints instanceof PNameCoder){
				pnc = (PNameCoder) hints;
			}
			else
				return null;
		}
		try{
			return pnc.decodeString(jonasCMRItem_Property);
		}
		catch(PException e){
			return null;
		}
	}

	public void paSetJonasCMRType_Property(PName val, Object connection){
		if(val.codingSupported((short) PNameCoder.CTSTRING)){
			try{
				jonasCMRType_Property = val.encodeString();
			}
			catch(Exception e){
			}
		}
		else{
			jonasCMRType_Property = "null";
		}
	}
	
	public PName paGetJonasCMRType_Property(Object hints){
		PNameCoder pnc;
		if(hints instanceof PClassMapping){
			PClassMapping pcm = (PClassMapping) hints;
			pnc = pcm.getPNameCoder("jonasCMRType_Property");
		}
		else{
			if(hints instanceof PNameCoder){
				pnc = (PNameCoder) hints;
			}
			else
				return null;
		}
		try{
			return pnc.decodeString(jonasCMRType_Property);
		}
		catch(PException e){
			return null;
		}
	}

	public void paSetName(java.lang.String val){
		name = val;
	}
	public java.lang.String paGetName() {
		return name;
	}

	public void paSetValue(java.lang.String val){
		value = val;
	}
	public java.lang.String paGetValue() {
		return value;
	}

	public Object getMemoryInstance(){
		return this;
	}
	
	
	public String toString(){
		StringBuffer s = new StringBuffer();
		s.append("data(");
					s.append(JONASAUTOPKFIELD + ",  ");
					s.append(jonasCMRItem_Property + ",  ");
					s.append(jonasCMRType_Property + ",  ");
					s.append(name + ",  ");
					s.append(value + ",  ");
				s.append(pName + ")");
		return s.toString();
	}
	
	
	public void read(PClassMapping pcm, PAccessor pa) throws PException{
		Olstore_propertyAccessor paccessor = null;
		PAccessorGen paccessorGen = null;
		if (pa == null)
			throw new PException("Accessor must not be null");
		else if (pa instanceof Olstore_propertyAccessor)
			paccessor = (Olstore_propertyAccessor) pa;
		else if (pa instanceof PAccessorGen)
			paccessorGen = (PAccessorGen) pa;
		else
			throw new PException("Wrong type of accessor: " + pa);
	 	try {	
			if(paccessor != null){
											paccessor.paSetJONASAUTOPKFIELD(paGetJONASAUTOPKFIELD());
															paccessor.paSetJonasCMRItem_Property(paGetJonasCMRItem_Property(pcm), null);
															paccessor.paSetJonasCMRType_Property(paGetJonasCMRType_Property(pcm), null);
															paccessor.paSetName(paGetName());
															paccessor.paSetValue(paGetValue());
							 			}
 			else{
	  		 			        		//paccessorGen.paSetOintField("JONASAUTOPKFIELD", paGetJONASAUTOPKFIELD(pcm), null);
	        			 						 						 			        		//paccessorGen.paSetStringField("name", paGetName(pcm), null);
	        			 			        		//paccessorGen.paSetStringField("value", paGetValue(pcm), null);
	        			        	 }  
		}
 		catch (PException pe) {
			throw pe;
		} catch (Exception e) {
			throw new PException(e.toString());
		} 
	}
	
	public void write(PClassMapping pcm, PAccessor pa) throws PException{
		Olstore_propertyAccessor paccessor = null;
		PAccessorGen paccessorGen = null;
		if (pa == null)
			throw new PExceptionProtocol("Accessor must not be null");
		else if (pa instanceof Olstore_propertyAccessor)
			paccessor = (Olstore_propertyAccessor) pa;
		else if (pa instanceof PAccessorGen)
			paccessorGen = (PAccessorGen) pa;
		else
			throw new PExceptionProtocol("Wrong type of accessor: " + pa);
		try {	
			if(paccessor != null){
											paSetJONASAUTOPKFIELD(paccessor.paGetJONASAUTOPKFIELD());
															paSetJonasCMRItem_Property(paccessor.paGetJonasCMRItem_Property(pcm), null);
															paSetJonasCMRType_Property(paccessor.paGetJonasCMRType_Property(pcm), null);
															paSetName(paccessor.paGetName());
															paSetValue(paccessor.paGetValue());
							 			}
 			else{
	  		 				        	//	paSetOintField(JONASAUTOPKFIELD, paccessorGen.paGetJONASAUTOPKFIELD());
        		//paSetOintField("JONASAUTOPKFIELD", paccessorGen.paGetOintField("JONASAUTOPKFIELD"));
        		//paSetJONASAUTOPKFIELD(paccessorGen.paGetOintField("JONASAUTOPKFIELD"), null);
	        			 						 						 				        	//	paSetStringField(name, paccessorGen.paGetName());
        		//paSetStringField("name", paccessorGen.paGetStringField("name"));
        		//paSetName(paccessorGen.paGetStringField("name"), null);
	        			 				        	//	paSetStringField(value, paccessorGen.paGetValue());
        		//paSetStringField("value", paccessorGen.paGetStringField("value"));
        		//paSetValue(paccessorGen.paGetStringField("value"), null);
	        			        	 }  
		}
 		catch (PException pe) {
			throw pe;
		} catch (Exception e) {
			throw new PException(e.toString());
		} 
	}
}